/*
	impiccato.c

	29-09-2005
	server gioco impiccato con semafori, memoria condivisa

*/

#include <stdio.h>
#include <time.h>
#include <errno.h>
#include "impiccato.h"

extern time_t time();

int maxlives = 12;
char *word[] = {
#include "words"
                                };

#define NUM_OF_WORDS    (sizeof(word)/sizeof(word[0]))

void gioca(long, long);

int main( void ) {
	MESSAGE m;
	extern int errno;

	srand((int)time((long *)0));    /* randomize the seed */

	while(1) 
		if (receive(ADDERKEY, &m, sizeof(m))) {
			if(m.op=='C'){
				if(fork() == 0) {
					gioca(getpid(), m.clientkey );
					exit(0);
				}
			} else {
				rmqueue(m.clientkey);	
				perror("Mancata connessione.");
			}
		}
}

void gioca(long in, long out) {
	MESSAGE m;
        char *whole_word, part_word[MAXLEN],
                  guess[MAXLEN];

        int lives = maxlives;
        int game_state ='G';
        int i, good_guess, word_length;
        char hostname[MAXLEN];

	m.clientkey=in;
	m.op = 'G';
        gethostname(hostname, MAXLEN);
        sprintf(m.buffer, "Giochi hangman on host %s", hostname);
        if(!send(out, &m, sizeof(m))) {
		printf("non posso inviare a %ld; errno = %d \n", m.clientkey, errno);
		return;
	}

        /* scelta della parola dalla lista */
        whole_word = word[rand() % NUM_OF_WORDS];
        word_length = strlen(whole_word);

        for(i=0; i < word_length; i++)
                part_word[i]='-';
        part_word[i]='\0';

	strcpy(m.buffer, part_word);
	m.lives = lives;
        if(!send(out, &m, sizeof(m))) {
		printf("non posso inviare a %ld; errno = %d \n", m.clientkey, errno);
		return;
	}
	while( game_state == 'G') {
		if(!receive(in, &m, sizeof(m))) {
                        printf("Errore comunicazione 2");
                        rmqueue(out);
                        return;
                }

                good_guess = 0;
                for(i=0; i<word_length; i++) {
                        if(m.buffer[i] == whole_word[i]) {
                                good_guess = 1;
                                part_word[i] = whole_word[i];
                        }
                }
                if(!good_guess) lives--;
                if(strcmp(whole_word, part_word)==0) 
                        m.op = game_state = 'V';  /* V ==> User vince  */
                else if(lives==0) {
                        m.op = game_state = 'X';  /* X==> User Lost  */
                        strcpy(part_word, whole_word);  /* Show User the word  */
                } else m.op = 'G';
		strcpy(m.buffer, part_word);
		m.lives = lives;
        	if(!send(out, &m, sizeof(m))) {
			printf("non posso inviare a %ld; errno = %d \n", m.clientkey, errno);
			return;
        	}
	}
	rmqueue(out);
}

